<?php
	$updatepacks= 'updates';
	$TitleHash = '4B8896F28DAE55B9223CBE2A2C2AE8FB'; //9.2.0-20J
	//
	$headers = getallheaders();
	$actions = trim($headers['SOAPAction']);
	$url = "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
	if (strpos($url, '.php')!==false) $cnt = dirname($url).'/'.$updatepacks;
	else $cnt = $url.$updatepacks;
	//Functions
	function replyheader() {
		header('Server: Apache/2.2.19',true);
		header('Keep-Alive: timeout=45, max=300',true);
		header('Content-Type: text/xml;charset=utf-8',true);
		header('HTTP/1.1 200 OK');
	}
	//
	switch ($actions) {
		case 'urn:nus.wsapi.broadon.com/GetSystemTitleHash':
			replyheader();
			$request = @file_get_contents('php://input');
			$parser = xml_parser_create();
			xml_parse_into_struct($parser, $request, $vals, $index);
			xml_parser_free($parser);
			$DeviceId =$vals[$index['NUS:DEVICEID'][0]]['value'];
			$MessageId=$vals[$index['NUS:MESSAGEID'][0]]['value'];
			$TimeStamp=time();
			$pats = array('/DEVICEID_HERE/','/MESSAGEID_HERE/','/TIMESTAMP_HERE/','/HASH_HERE/');
			$reps = array($DeviceId, $MessageId, $TimeStamp,$TitleHash);
			$reply= @file_get_contents('GetSystemTitleHash.template.xml');
			print(preg_replace($pats, $reps, $reply));
			break;
		case 'urn:ecs.wsapi.broadon.com/GetAccountStatus':
			replyheader();
			$request = @file_get_contents('php://input');
			$parser = xml_parser_create();
			xml_parse_into_struct($parser, $request, $vals, $index);
			xml_parser_free($parser);
			$DeviceId =$vals[$index['ECS:DEVICEID'][0]]['value'];
			$MessageId=$vals[$index['ECS:MESSAGEID'][0]]['value'];
			$TimeStamp=time();
			$pats = array('/DEVICEID_HERE/','/MESSAGEID_HERE/','/TIMESTAMP_HERE/','/HASH_HERE/','/UPDATE_HERE/','/URL_HERE/');
			$reps = array($DeviceId, $MessageId, $TimeStamp,$TitleHash,$cnt,$url);
			$reply= @file_get_contents('GetAccountStatus.template.xml');
			print(preg_replace($pats, $reps, $reply));
			break;
		case 'urn:nus.wsapi.broadon.com/GetSystemUpdate':
			replyheader();
			$request = @file_get_contents('php://input');
			$parser = xml_parser_create();
			xml_parse_into_struct($parser, $request, $vals, $index);
			xml_parser_free($parser);
			$DeviceId =$vals[$index['NUS:DEVICEID'][0]]['value'];
			$MessageId=$vals[$index['NUS:MESSAGEID'][0]]['value'];
			$TimeStamp=time();
			$TitleList='';
			if (is_file($updatepacks.'/GetSystemUpdate.partial.xml')) 
				$TitleList = file_get_contents($updatepacks.'/GetSystemUpdate.partial.xml');
			$pats = array('/DEVICEID_HERE/','/MESSAGEID_HERE/','/TIMESTAMP_HERE/','/HASH_HERE/','/UPDATE_HERE/','/URL_HERE/','/TITLELIST_HERE/');
			$reps = array($DeviceId, $MessageId, $TimeStamp,$TitleHash,$cnt,$url,$TitleList);
			$reply= @file_get_contents('GetSystemUpdate.template.xml');
			print(preg_replace($pats, $reps, $reply));
			break;
		case 'urn:nus.wsapi.broadon.com/GetSystemCommonETicket':
			replyheader();
			$request = @file_get_contents('php://input');
			$parser = xml_parser_create();
			xml_parse_into_struct($parser, $request, $vals, $index);
			xml_parser_free($parser);
			$DeviceId =$vals[$index['NUS:DEVICEID'][0]]['value'];
			$MessageId=$vals[$index['NUS:MESSAGEID'][0]]['value'];
			$TimeStamp=time();
			$Ticket  = '';
			foreach ($index['NUS:TITLEID'] as $TitleIdx) {
				$TitleId = $vals[$TitleIdx]['value'];
				if (is_file($updatepacks.'/'.$TitleId.'/cetk.base64'))
					$Ticket=$Ticket.'<CommonETicket>'.file_get_contents($updatepacks.'/'.$TitleId.'/cetk.base64').'</CommonETicket>';
			}
			$pats = array('/DEVICEID_HERE/','/MESSAGEID_HERE/','/TIMESTAMP_HERE/','/HASH_HERE/','/UPDATE_HERE/','/URL_HERE/','/TICKET_HERE/');
			$reps = array($DeviceId, $MessageId, $TimeStamp,$TitleHash,$cnt,$url,$Ticket);
			$reply= @file_get_contents('GetSystemCommonETicket.template.xml');
			print(preg_replace($pats, $reps, $reply));
			break;
		case '':
			header('Content-Type: text/html;charset=utf-8',true);
			echo '<html><head><title>SOAPTest</title></head><body>Private Server to update 3ds.<br/>Folders: Url='.$url.', Update='.$cnt.'<br/>';
			echo 'Accept: GetSystemTitleHash, GetAccountStatus, GetSystemUpdate.</body></html>';
			break;
		default:
			header('Content-Type: text/html;charset=utf-8',true);
			echo '<html><head><title>SOAPTest</title></head><body>Private Server to update 3ds.<br/>Folders: Url='.$url.', Update='.$cnt.'<br/>';
			echo 'Accept: GetSystemTitleHash, GetAccountStatus, GetSystemUpdate.';
			echo ' Unsupported SOAPAction:'.$actions.'</body></html>';
			break;
	}
?>